unit esb_00_lib;

interface

Uses
  FileCtrl,
  Classes,
  SysUTILS;


Const
  sDirTask = 'TASK\';

Var
  MainDir:string;

//  ()
function Dir_Create(DirName: String): boolean;
//  ""     
function Dir_LastPart_Extract(sDir: string; sDelims: string = '\/:'): string;
//   ()
function DirName_Normal(DirName: String; sSep: string = '\'): string;
//  ()
function Dir_Select(Dir: string): string;
// -    Sx. UnChar -  
function Get_CountWords_In_String(Sx : String; UnChar: String=' '; YesAllTrim_Before: boolean=true) : integer;
//    Sx   NumWord. UnChar -  
function Get_Word_From_String(Sx : String; NumWord : integer; UnChar: String=' '; YesAllTrim_Before: boolean=true) : String;
// 
function InversionString(Sx : string) : string;

implementation

function Dir_Create(DirName: String): boolean;
//  ()
begin
  Result := false;
  DirName := trim(DirName);
  if length(DirName) > 0 then begin
     if DirName[length(DirName)] <> '\' then DirName := DirName + '\';
     Result := ForceDirectories(DirName);
     if Result then begin
        Result := DirectoryExists(DirName);
     end;
  end;
end;

function Dir_LastPart_Extract(sDir: string; sDelims: string = '\/:'): string;
//   ""     
begin
  Result := trim(ExtractFilePath(sDir));
  if length(Result) > 0 then begin
     sDelims := trim(sDelims);
     if length(sDelims) <= 0 then sDelims := '\/:';
     if POS(Result[length(Result)], sDelims) > 0 then begin
        Result[length(Result)] := ' ';
        Result := trim(Result);
     end;
  end;
  if length(Result) > 0 then begin
     Result := InversionString(Result);
     Result := trim(Get_Word_From_String(Result, 1, sDelims, true));
     Result := InversionString(Result);
  end;
end;

function DirName_Normal(DirName: String; sSep: string = '\'): string;
//   ()
begin
   Result := trim(DirName);
   if length(Result) > 0 then begin
      sSep := trim(sSep);
      if length(sSep) <= 0 then  sSep := '\';
      if Result[length(Result)] <> sSep[1] then Result := Result + sSep[1];
   end;
end;

function Dir_Select(Dir: string): string;
//  ()
const
  SELDIRHELP = 1000;
begin
   Result := '';
   Dir := trim(Dir);
   if not DirectoryExists(Dir) then begin
      Dir := '';
   end;
   if SelectDirectory(Dir, [sdAllowCreate, sdPerformCreate, sdPrompt], SELDIRHELP) then begin
      Dir := DirName_Normal(Dir);
      if DirectoryExists(Dir) then begin
         Result := Dir;
      end;
   end;
end;

function InversionString(Sx : string) : string;
// 
Var
  i : integer;
begin
  Result:=Sx;
  if Length(Sx)>0 then begin
     Result:='';
     for i:=Length(Sx) downto 1 do
      begin
        Result:=Result+Sx[i];
     end;
  end;
end;

function Get_Word_From_String(Sx : String; NumWord : integer; UnChar: String=' '; YesAllTrim_Before: boolean=true) : String;
//    Sx   NumWord. UnChar -  
//YesAllTrim_Before -  TRUE,          
Var
  InWord    : byte;
  NumWordCur, i : integer;
begin
  Result:='';
  if YesAllTrim_Before then Sx:=trim(Sx);
  if length(Sx)>0 then begin
     if NumWord>0 then begin
        InWord := 0;
        NumWordCur:=0;
        i:=0;
        while i<length(Sx) do
         begin
          i:=i+1;
          if POS(Sx[i],UnChar)<=0 then begin //  -  
             if InWord<=0 then NumWordCur:=NumWordCur+1; // -   
             InWord:=1; //  
             if NumWordCur=NumWord then begin // -  
                Result:=Result+Sx[i];   //     
             end;
          end
          else begin  //  - 
             InWord:=0; //  
             if NumWordCur=NumWord then begin //  -  
                i:=length(Sx)+1; //,     
             end;
          end;
        end;
     end;
  end;
end;

function Get_CountWords_In_String(Sx : String; UnChar: String=' '; YesAllTrim_Before: boolean=true) : integer;
// -    Sx. UnChar -  
var
  InWord : byte;
  i : integer;
begin
  Result:=0;
  if YesAllTrim_Before then Sx:=trim(Sx);
  if length(Sx)>0 then begin
     InWord := 0;
     i:=0;
     while i<length(Sx) do
      begin
       i:=i+1;
       if POS(Sx[i],UnChar)<=0 then begin //  -  
          if InWord<=0 then Result:=Result+1; //   
          InWord:=1; //  
       end
       else begin //  - 
          InWord:=0; //  
       end;
     end;
  end;
end;


end.




