unit esb_01_main;

interface

uses
  __es_bayes,
  esb_00_lib,
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls, Vcl.ComCtrls,
  Vcl.Buttons, Vcl.CheckLst, Vcl.Grids, Vcl.Menus;

type
  TfMain = class(TForm)
    Label1: TLabel;
    Panel1: TPanel;
    Timer1: TTimer;
    LabelDT: TLabel;
    PCmain: TPageControl;
    tsSel: TTabSheet;
    tsTrain: TTabSheet;
    tsCtrl: TTabSheet;
    GroupBox1: TGroupBox;
    Panel2: TPanel;
    Label2: TLabel;
    sbTaskOpen: TSpeedButton;
    Label3: TLabel;
    sbTaskNew: TSpeedButton;
    Label4: TLabel;
    sbTaskSave: TSpeedButton;
    Label5: TLabel;
    Edit_TaskDirName: TEdit;
    Panel3: TPanel;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    Splitter1: TSplitter;
    Memo_Obj: TMemo;
    Memo_Prop: TMemo;
    Label_TaskName: TLabel;
    Panel4: TPanel;
    GroupBox4: TGroupBox;
    Splitter2: TSplitter;
    gbProp: TGroupBox;
    lbObj: TListBox;
    clbProp: TCheckListBox;
    Splitter3: TSplitter;
    Panel5: TPanel;
    GroupBox6: TGroupBox;
    Splitter4: TSplitter;
    GroupBox7: TGroupBox;
    sgRating: TStringGrid;
    sgRules: TStringGrid;
    Panel_Info: TPanel;
    GroupBox8: TGroupBox;
    Splitter5: TSplitter;
    Panel7: TPanel;
    GroupBox9: TGroupBox;
    clbPropR: TCheckListBox;
    GroupBox10: TGroupBox;
    lbObjR: TListBox;
    Panel9: TPanel;
    sbRecogn: TSpeedButton;
    Panel10: TPanel;
    Splitter6: TSplitter;
    Panel11: TPanel;
    Splitter7: TSplitter;
    Splitter8: TSplitter;
    GroupBox11: TGroupBox;
    sgRulesR: TStringGrid;
    Label_Info: TLabel;
    gbPropTrue: TGroupBox;
    MemoPropTrue: TMemo;
    Splitter_PropTrue: TSplitter;
    Panel_Prop_True_Create: TPanel;
    sb_Prop_True_Create: TSpeedButton;
    Panel8: TPanel;
    sb_Prop_True_Clear: TSpeedButton;
    GroupBox5: TGroupBox;
    Splitter9: TSplitter;
    GroupBox12: TGroupBox;
    sgRatingR: TStringGrid;
    lbObjRfuzziR: TListBox;
    pmProps: TPopupMenu;
    pmPropsR: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    N7: TMenuItem;
    N8: TMenuItem;
    N9: TMenuItem;
    N10: TMenuItem;
    LabelVersionES: TLabel;
    Memo_Res: TMemo;
    Panel12: TPanel;
    sbInit: TSpeedButton;
    Label6: TLabel;
    Panel_Train_Mode: TPanel;
    Label7: TLabel;
    rbManual: TRadioButton;
    rbAuto: TRadioButton;
    Splitter10: TSplitter;
    Panel14: TPanel;
    sbStop: TSpeedButton;
    Label10: TLabel;
    Label_CycleNum: TLabel;
    Splitter11: TSplitter;
    Label8: TLabel;
    Panel6: TPanel;
    sbStart: TSpeedButton;
    Label9: TLabel;
    Label11: TLabel;
    sbNextM: TSpeedButton;
    Label12: TLabel;
    Label13: TLabel;
    Edit_MaxCycle: TEdit;
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure sbTaskOpenClick(Sender: TObject);
    procedure sbTaskSaveClick(Sender: TObject);
    procedure sbTaskNewClick(Sender: TObject);
    procedure Edit_TaskDirNameChange(Sender: TObject);
    procedure PCmainChange(Sender: TObject);
    procedure sbInitClick(Sender: TObject);
    procedure sbStartClick(Sender: TObject);
    procedure rbManualClick(Sender: TObject);
    procedure rbAutoClick(Sender: TObject);
    procedure sbNextMClick(Sender: TObject);
    procedure sbStopClick(Sender: TObject);
    procedure sbRecognClick(Sender: TObject);
    procedure sb_Prop_True_ClearClick(Sender: TObject);
    procedure sb_Prop_True_CreateClick(Sender: TObject);
    procedure lbObjClick(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure N3Click(Sender: TObject);
    procedure N5Click(Sender: TObject);
    procedure N10Click(Sender: TObject);
    procedure N6Click(Sender: TObject);
    procedure N8Click(Sender: TObject);
  private
    { Private declarations }
    fItsFirst:boolean;

    //:  
    fES_bayes : TES_bayes;


    procedure ES_BeforeTrain(Sender: TObject); //TES_Common_Event
    procedure ES_AfterTrain(Sender: TObject); //TES_Common_Event
    procedure ES_BeforeCycle(Sender: TObject; CycleNum:integer); //TES_Auto_Cycle_Before_Event
    procedure ES_AfterCycle(Sender: TObject; CycleNum:integer; TR:TTrainResult; TPE:TTrainProcessExit); //TES_Auto_Cycle_After_Event
    procedure ES_BeforeCycleStep(Sender: TObject; CycleNum:integer; ObjTrainIndex:integer); //TES_Auto_Cycle_Step_Before_Event
    procedure ES_AfterCycleStep(Sender: TObject; CycleNum:integer; ObjTrainIndex:integer; TOR:TObjTrainResult); //TES_Auto_Cycle_Step_After_Event


  public
    { Public declarations }

    function TaskLoad(FullDirTask:string):boolean;
    function sgRules_SaveToFile:boolean;
    function sgRules_LoadFromFile(SG:TStringGrid):boolean;

  end;

var
  fMain: TfMain;

implementation

{$R *.dfm}


procedure TfMain.FormCreate(Sender: TObject);
begin
  fItsFirst:=true;
  MainDir:=ExtractFilePath(ParamStr(0));
  Dir_Create(MainDir+sDirTask);

  //fES_bayes := TES_bayes.Create(Self);
  fES_bayes := TES_bayes.Create(nil);


  fES_bayes.BeforeTrain := ES_BeforeTrain;
  fES_bayes.AfterTrain  := ES_AfterTrain;
  fES_bayes.BeforeCycle := ES_BeforeCycle;
  fES_bayes.AfterCycle  := ES_AfterCycle;
  fES_bayes.BeforeStep  := ES_BeforeCycleStep;
  fES_bayes.AfterStep   := ES_AfterCycleStep;

  PCmain.ActivePage := tsSel;

  Timer1.Enabled:=true;

end;

procedure TfMain.FormDestroy(Sender: TObject);
begin

  fES_bayes.BeforeTrain := nil;
  fES_bayes.AfterTrain  := nil;
  fES_bayes.BeforeCycle := nil;
  fES_bayes.AfterCycle  := nil;
  fES_bayes.BeforeStep  := nil;
  fES_bayes.AfterStep   := nil;

  FreeAndNil(fES_bayes);

end;


procedure TfMain.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled:=false;
  LabelDT.Caption:=DateTimeToStr(NOW);

  if fItsFirst then begin
     Timer1.Interval:=1000;
     Self.WindowState:=wsMaximized;

     LabelVersionES.Caption:=' : '+fES_bayes.Version;

     //---------------------
     //  -      
     TaskLoad(MainDir+sDirTask+'001_--\');
     //---------------------

     Edit_MaxCycle.Text := IntToStr(fES_bayes.TrainCycleMaxCount);

     fItsFirst:=false;
  end;
  Timer1.Enabled:=true;
end;


//**********************************************************
//**********************************************************
//**********************************************************
//  TES_bayes
procedure TfMain.ES_BeforeTrain(Sender: TObject);
//TES_Common_Event
begin
  Label_Info.Font.Color:=clBlack;
  Label_Info.Color:=clBtnFace;
  Label_Info.Caption:=' . ';
  Label_CycleNum.Caption:='-';
  Memo_Res.Lines.Clear;
  Memo_Res.Lines.Add(' . : '+DateTimeToStr(NOW));
  Memo_Res.Lines.Add('**************************************');
end;
procedure TfMain.ES_AfterTrain(Sender: TObject);
//TES_Common_Event
begin
  if fES_bayes.TrainResult = trYes then begin
     Label_Info.Font.Color:=clBlack;
     Label_Info.Color:=clBtnFace;
  end
  else begin
     Label_Info.Font.Color:=clRed;
     Label_Info.Color:=clYellow;
  end;
  Label_Info.Caption:=' . . : '+fES_bayes.TrainResult_to_Str(fES_bayes.TrainResult, true);
  Memo_Res.Lines.Add('**************************************');
  Memo_Res.Lines.Add(' . : '+DateTimeToStr(NOW));
  Memo_Res.Lines.Add('    : '+fES_bayes.TrainProcessExit_to_Str(fES_bayes.TrainProcessExit));
  Memo_Res.Lines.Add('  : '+fES_bayes.TrainResult_to_Str(fES_bayes.TrainResult));
end;
procedure TfMain.ES_BeforeCycle(Sender: TObject; CycleNum:integer);
//TES_Auto_Cycle_Before_Event
begin
  Label_CycleNum.Caption:='-'+IntToStr(CycleNum);
  Memo_Res.Lines.Add('====================');
  Memo_Res.Lines.Add(' : '+IntToStr(CycleNum));

end;
procedure TfMain.ES_AfterCycle(Sender: TObject; CycleNum:integer; TR:TTrainResult; TPE:TTrainProcessExit);
//TES_Auto_Cycle_After_Event
begin
  Memo_Res.Lines.Add(' : '+IntToStr(CycleNum));
  Memo_Res.Lines.Add('====================');
end;
procedure TfMain.ES_BeforeCycleStep(Sender: TObject; CycleNum:integer; ObjTrainIndex:integer);
//TES_Auto_Cycle_Step_Before_Event
Var
  Sx:string;
begin
  Sx:='-'+IntToStr(CycleNum)+'. -'+IntToStr(ObjTrainIndex);
  if (ObjTrainIndex>=0) and (ObjTrainIndex<lbObj.Items.Count) then begin
     Sx:=Sx+' ('+trim(lbObj.Items[ObjTrainIndex])+')';
  end
  else begin
     Sx:=Sx+' (???)';
  end;
  Label_CycleNum.Caption:=Sx;
  Memo_Res.Lines.Add('-------------------');
  Memo_Res.Lines.Add(': '+IntToStr(CycleNum)+'.  (): '+IntToStr(ObjTrainIndex)+'.  ');
end;
procedure TfMain.ES_AfterCycleStep(Sender: TObject; CycleNum:integer; ObjTrainIndex:integer; TOR:TObjTrainResult);
//TES_Auto_Cycle_Step_After_Event
begin
  Memo_Res.Lines.Add('      : '+fES_bayes.ObjTrainResult_to_Str(TOR));
  Memo_Res.Lines.Add(': '+IntToStr(CycleNum)+'.  (): '+IntToStr(ObjTrainIndex)+'.  ');
  Memo_Res.Lines.Add('-------------------');
end;
//**********************************************************
//**********************************************************
//**********************************************************



procedure TfMain.Edit_TaskDirNameChange(Sender: TObject);
begin
  Label_TaskName.Caption := ': '+Edit_TaskDirName.Text;
end;

procedure TfMain.lbObjClick(Sender: TObject);
Var
  I:integer;
  sName,S:string;
begin
  Application.ProcessMessages;
  if rbAuto.Checked then begin
     if lbObj.ItemIndex>=0 then begin
        I:=-1;
        while I<(clbProp.Items.Count-1) do
         begin
           I:=I+1;
           clbProp.Checked[I]:=false;
           sName:=IntToStr(lbObj.ItemIndex)+'_'+IntToStr(I);
           S:=trim(MemoPropTrue.Lines.Values[sName]);
           if StrToIntDef(S,0)>0 then clbProp.Checked[I]:=true;
        end;
     end;
  end;
end;

procedure TfMain.N10Click(Sender: TObject);
Var
  I:integer;
begin
  Application.ProcessMessages;
  for I:=0 to (clbPropR.Items.Count-1) do
   begin
     clbPropR.Checked[I]:= not clbPropR.Checked[I];
  end;
end;

procedure TfMain.N1Click(Sender: TObject);
Var
  I:integer;
begin
  Application.ProcessMessages;
  for I:=0 to (clbProp.Items.Count-1) do
   begin
     clbProp.Checked[I]:=true;
  end;
end;

procedure TfMain.N3Click(Sender: TObject);
Var
  I:integer;
begin
  Application.ProcessMessages;
  for I:=0 to (clbProp.Items.Count-1) do
   begin
     clbProp.Checked[I]:=false;
  end;
end;

procedure TfMain.N5Click(Sender: TObject);
Var
  I:integer;
begin
  Application.ProcessMessages;
  for I:=0 to (clbProp.Items.Count-1) do
   begin
     clbProp.Checked[I]:= not clbProp.Checked[I];
  end;
end;


procedure TfMain.N6Click(Sender: TObject);
Var
  I:integer;
begin
  Application.ProcessMessages;
  for I:=0 to (clbPropR.Items.Count-1) do
   begin
     clbPropR.Checked[I]:= true;
  end;
end;

procedure TfMain.N8Click(Sender: TObject);
Var
  I:integer;
begin
  Application.ProcessMessages;
  for I:=0 to (clbPropR.Items.Count-1) do
   begin
     clbPropR.Checked[I]:= false;
  end;
end;

procedure TfMain.PCmainChange(Sender: TObject);
Var
  J : integer;
begin
  Application.ProcessMessages;
  if PCmain.ActivePage = tsTrain then begin
     lbObj.Items.Assign(Memo_Obj.Lines);
     clbProp.Items.Assign(Memo_Prop.Lines);
     fES_bayes.Obj_Rating_TStringGrid_Clear(sgRating);
     //fES_bayes.Rules_TStringGrid_Clear(sgRules);
     sgRules_LoadFromFile(sgRules);
     Memo_Res.Lines.Clear;

     if lbObj.Items.Count>0 then begin
        lbObj.ItemIndex:=0;
        lbObjClick(nil);
     end
     else begin
        MemoPropTrue.Lines.Clear;
     end;

  end;
  if PCmain.ActivePage = tsCtrl then begin
     lbObjR.Items.Assign(Memo_Obj.Lines);
     clbPropR.Items.Assign(Memo_Prop.Lines);
     lbObjR.ItemIndex:=-1;
     //sgRules_LoadFromFile(sgRules);
     fES_bayes.Obj_Rating_TStringGrid_Clear(sgRatingR);

     fES_bayes.Init(lbObjR.Items.Count, clbPropR.Items.Count);

     for J:=0 to (lbObjR.Items.Count-1) do
      begin
       fES_bayes.Obj_Add(J+1);
     end;
     for J:=0 to (clbPropR.Items.Count-1) do
      begin
       fES_bayes.Prop_Add(J+1);
     end;

     fES_bayes.Obj_Rating_to_TStringGrid(sgRatingR);
     for J:=1 to (sgRatingR.RowCount-1) do
      begin
        sgRatingR.Cells[1,J]:=lbObjR.Items[J-1];
     end;

     sgRules_LoadFromFile(sgRulesR);

     fES_bayes.Rules_From_TStringGrid(sgRulesR);

  end;
end;

procedure TfMain.rbAutoClick(Sender: TObject);
begin
  Application.ProcessMessages;
  sbNextM.Enabled:=false;
end;

procedure TfMain.rbManualClick(Sender: TObject);
begin
  Application.ProcessMessages;
  sbNextM.Enabled:=false;
end;

function TfMain.TaskLoad(FullDirTask:string):boolean;
begin
  Result:=false;
  Edit_TaskDirName.Text:='';
  FullDirTask:=trim(FullDirTask);
  Memo_Obj.Lines.Clear;
  Memo_Prop.Lines.Clear;
  MemoPropTrue.Lines.Clear;
  Memo_Res.Lines.Clear;
  lbObjRfuzziR.Items.Clear;
  Label_CycleNum.Caption:='';
  Label_Info.Caption:='';
  lbObj.Items.Clear;
  clbProp.Items.Clear;
  fES_bayes.Obj_Rating_TStringGrid_Clear(sgRating);
  fES_bayes.Rules_TStringGrid_Clear(sgRules);
  lbObjR.Items.Clear;
  clbPropR.Items.Clear;
  fES_bayes.Obj_Rating_TStringGrid_Clear(sgRatingR);
  fES_bayes.Rules_TStringGrid_Clear(sgRulesR);

  if FullDirTask<>'' then begin
     if DirectoryExists(FullDirTask) then begin
        Result:=true;
        Edit_TaskDirName.Text:=Dir_LastPart_Extract(FullDirTask);
        if FileExists(FullDirTask+'\' + 'ObjList.txt') then begin
           Memo_Obj.Lines.LoadFromFile(FullDirTask+'\' + 'ObjList.txt');
        end;
        if FileExists(FullDirTask+'\' + 'PropList.txt') then begin
           Memo_Prop.Lines.LoadFromFile(FullDirTask+'\' + 'PropList.txt');
        end;
        if FileExists(FullDirTask+'\' + 'PropListTrue.txt') then begin
           MemoPropTrue.Lines.LoadFromFile(FullDirTask+'\' + 'PropListTrue.txt');
        end;
     end;
  end;
end;


procedure TfMain.sbTaskOpenClick(Sender: TObject);
begin
  Application.ProcessMessages;
  TaskLoad(Dir_Select(MainDir+sDirTask+trim(Edit_TaskDirName.Text)));
end;

procedure TfMain.sbTaskNewClick(Sender: TObject);
Var
  sDir:string;
begin
  Application.ProcessMessages;
  {
  Edit_TaskDirName.Text:='';
  Memo_Obj.Lines.Clear;
  Memo_Prop.Lines.Clear;
  }
  {
  Edit_TaskDirName.Text:='';
  FullDirTask:=trim(FullDirTask);
  Memo_Obj.Lines.Clear;
  Memo_Prop.Lines.Clear;
  MemoPropTrue.Lines.Clear;
  Memo_Res.Lines.Clear;
  lbObjRfuzziR.Items.Clear;
  Label_CycleNum.Caption:='';
  Label_Info.Caption:='';
  }


  lbObjRfuzziR.Items.Clear;
  Label_CycleNum.Caption:='';
  Label_Info.Caption:='';

  sDir:='_';
  if InputQuery(' ','   ',sDir) then begin
     sDir:=trim(sDir);
     if sDir<>'' then begin
        if sDir[length(sDir)]='\' then sDir[length(sDir)]:=' ';
        if sDir[length(sDir)]='/' then sDir[length(sDir)]:=' ';
        sDir:=trim(sDir);
     end;
     if sDir<>'' then begin
        Dir_Create(MainDir+sDirTask+sDir);
        if DirectoryExists(MainDir+sDirTask+sDir) then begin
           Edit_TaskDirName.Text:=sDir;

           Memo_Obj.Lines.Clear;
           Memo_Prop.Lines.Clear;
           MemoPropTrue.Lines.Clear;
           Memo_Res.Lines.Clear;
           lbObjRfuzziR.Items.Clear;
           Label_CycleNum.Caption:='';
           Label_Info.Caption:='';

           lbObj.Items.Clear;
           clbProp.Items.Clear;
           fES_bayes.Obj_Rating_TStringGrid_Clear(sgRating);
           fES_bayes.Rules_TStringGrid_Clear(sgRules);

           lbObjR.Items.Clear;
           clbPropR.Items.Clear;
           fES_bayes.Obj_Rating_TStringGrid_Clear(sgRatingR);
           fES_bayes.Rules_TStringGrid_Clear(sgRulesR);

        end;
     end;
  end;
end;

procedure TfMain.sbTaskSaveClick(Sender: TObject);
begin
  Application.ProcessMessages;
  if DirectoryExists(MainDir+sDirTask+Edit_TaskDirName.Text) then begin
     Memo_Obj.Lines.SaveToFile(MainDir+sDirTask+Edit_TaskDirName.Text+'\' + 'ObjList.txt');
     Memo_Prop.Lines.SaveToFile(MainDir+sDirTask+Edit_TaskDirName.Text+'\' + 'PropList.txt');
  end
  else begin
     ShowMessage('!    !');
  end;
end;

procedure TfMain.sbInitClick(Sender: TObject);
Var
  J:integer;
begin
  Application.ProcessMessages;

  Label_Info.Caption:='...';

  lbObj.Items.Assign(Memo_Obj.Lines);
  clbProp.Items.Assign(Memo_Prop.Lines);
  fES_bayes.Obj_Rating_TStringGrid_Clear(sgRating);
  fES_bayes.Rules_TStringGrid_Clear(sgRules);
  if lbObj.Items.Count>0 then lbObj.ItemIndex:=0;
  Memo_Res.Lines.Clear;

  sbNextM.Enabled:=false;

  //Memo_Res.Lines.Clear;

  fES_bayes.Obj_Rating_TStringGrid_Clear(sgRating);
  fES_bayes.Rules_TStringGrid_Clear(sgRules);

  if lbObj.Items.Count>0 then lbObj.ItemIndex:=0;

  //================
  fES_bayes.Init(lbObj.Items.Count, clbProp.Items.Count);
  //================


  for J:=0 to (lbObj.Items.Count-1) do
   begin
    fES_bayes.Obj_Add(J+1);
  end;
  for J:=0 to (clbProp.Items.Count-1) do
   begin
    fES_bayes.Prop_Add(J+1);
  end;

  fES_bayes.Obj_Rating_to_TStringGrid(sgRating);
  for J:=1 to (sgRating.RowCount-1) do
   begin
     sgRating.Cells[1,J]:=lbObj.Items[J-1];
  end;

  fES_bayes.Rules_to_TStringGrid(sgRules);


  lbObjClick(nil);

  Label_CycleNum.Caption:=': '+IntToStr(fES_bayes.TrainCycle)+'.  : '+IntToStr(fES_bayes.TrainStep);
  Label_Info.Caption:='. OK';

end;


procedure TfMain.sbRecognClick(Sender: TObject);
Var
  ListProp:TStrings;
  I,J:integer;
  ObjRecognJ:integer;
begin
  Application.ProcessMessages;
  lbObjR.ItemIndex:=-1;
  if lbObjR.Items.Count>1 then begin
     Screen.Cursor:=crHourGlass;
     ListProp:=TStringList.Create;
     TRY
       lbObjRfuzziR.Visible:=false;
       lbObjRfuzziR.Items.Clear;
       for i:=0 to (clbPropR.Items.Count-1) do
        begin
         if clbPropR.Checked[i] then begin
            ListProp.Add('1');
         end
         else begin
            ListProp.Add('0');
         end;
       end;

       ObjRecognJ:=fES_bayes.Obj_Recognize(ListProp, lbObjRfuzziR.Items);
       if lbObjRfuzziR.Items.Count>1 then begin
          for I := 0 to (lbObjRfuzziR.Items.Count-1) do
           begin
            J:=StrToIntDef(trim(lbObjRfuzziR.Items[I]),-1);
            if J>=0 then begin
               lbObjRfuzziR.Items[I]:=lbObjR.Items[J];
            end;
          end;
          lbObjRfuzziR.Visible:=true;
       end;

       fES_bayes.Obj_Rating_to_TStringGrid(sgRatingR);

       for J:=1 to (sgRatingR.RowCount-1) do
        begin
          sgRatingR.Cells[1,J]:=lbObjR.Items[J-1];
       end;


       if ObjRecognJ>=0 then begin
          lbObjR.ItemIndex:=ObjRecognJ;
          if (ObjRecognJ+1) < sgRatingR.RowCount then begin
             sgRatingR.Row:=ObjRecognJ+1;
          end;
       end
       else begin
          Screen.Cursor:=crDefault;
          ShowMessage('  .    ...');
       end;

     FINALLY
       FreeAndNil(ListProp);
       Screen.Cursor:=crDefault;
     END;
  end;
end;

procedure TfMain.sbStartClick(Sender: TObject);
Var
  I,J: integer;
  TM:TTrainMode;
begin
  Application.ProcessMessages;
  if fES_bayes.ComponentInitOK then begin
     if MessageDlg('       ?', mtConfirmation, mbOkCancel, 0)=mrOk then begin
        Screen.Cursor:=crHourGlass;
        Memo_Res.Lines.Clear;
        TRY

          Label_Info.Caption:='...';

          sbStop.Enabled:=true;
          sbStart.Enabled:=false;
          //-------------------------------------
          if rbManual.Checked then begin
             TM := ES_tmManual;
             sbNextM.Enabled:=true;
          end
          else begin
             TM := ES_tmAuto;
             sbNextM.Enabled:=false;
          end;
          //-------------------------------------
          //-------------------------------------
          if DirectoryExists(MainDir+sDirTask+Edit_TaskDirName.Text) then begin
             MemoPropTrue.Lines.SaveToFile(MainDir+sDirTask+Edit_TaskDirName.Text+'\' + 'PropListTrue.txt');
          end
          else begin
             //ShowMessage('!    !');
          end;
          //-------------------------------------

          //-------------------------------------
          J:=StrToIntDef(trim(Edit_MaxCycle.Text),0);
          if J<3 then J:=3;
          if J>1000 then J:=1000;
          fES_bayes.TrainCycleMaxCount:=J;
          Edit_MaxCycle.Text := IntToStr(fES_bayes.TrainCycleMaxCount);
          //-------------------------------------


          {
          fES_bayes.Obj_Rating_to_TStringGrid(sgRating);
          for J:=1 to (sgRating.RowCount-1) do
           begin
             sgRating.Cells[1,J]:=lbObj.Items[J-1];
          end;
          fES_bayes.Rules_to_TStringGrid(sgRules);
          }


          //==============================================
          if TM=ES_tmAuto then begin
             //-------------------------------------
             //   
             fES_bayes.ES_Train_Start(TM, MemoPropTrue.Lines);
             //-------------------------------------
             //-------------------------------------
             fES_bayes.Obj_Rating_to_TStringGrid(sgRating);
             fES_bayes.Rules_to_TStringGrid(sgRules);
             sgRules_SaveToFile;
             //-------------------------------------
             //-------------------------------------
             Memo_Res.Lines.Clear;
             Memo_Res.Lines.Add(' : '+fES_bayes.TrainMode_to_Str(fES_bayes.TrainMode, true));
             Memo_Res.Lines.Add('  : '+fES_bayes.TrainProcessExit_to_Str(fES_bayes.TrainProcessExit, true));
             Memo_Res.Lines.Add(' : '+fES_bayes.TrainResult_to_Str(fES_bayes.TrainResult, true));
             //-------------------------------------
             //-------------------------------------
             for J:=1 to (sgRating.RowCount-1) do
              begin
                sgRating.Cells[1,J]:=lbObj.Items[J-1];
             end;
             //-------------------------------------
             //-------------------------------------
             Label_Info.Font.Color:=clBlack;
             Label_Info.Color:=clBtnFace;
             //-------------------------------------
             if fES_bayes.TrainProcessExit=tpeExitForLimit then begin
                Label_Info.Font.Color:=clYellow;
                Label_Info.Color:=clRed;
                Label_Info.Caption:='   ,    !!!';
             end
          end;
          //==============================================

          //==============================================
          if TM=ES_tmManual then begin
             Label_Info.Caption:='.   ""';
             //-------------------------------------
             //   
             fES_bayes.ES_Train_Start(TM, MemoPropTrue.Lines);
             //-------------------------------------
          end;
          //==============================================

        FINALLY
          if TM=ES_tmAuto then begin
             sbStart.Enabled:=true;
             sbStop.Enabled:=false;
          end;
          Screen.Cursor:=crDefault;
        END;
     end;
  end
  else begin
     ShowMessage('.    ');
  end;
end;

procedure TfMain.sbNextMClick(Sender: TObject);
Var
  //ListProp:TStrings;
  J:integer;
  Sx:string;
begin
  Application.ProcessMessages;

  Label_Info.Font.Color:=clBlack;
  Label_Info.Color:=clBtnFace;
  Label_Info.Caption:='...';

  if fES_bayes.InTraining then begin

     if fES_bayes.TrainCycle>=fES_bayes.TrainCycleMaxCount then begin
        Label_Info.Font.Color:=clYellow;
        Label_Info.Color:=clRed;
        Label_Info.Caption:='  ,    !!!';
     end
     else begin
       Label_Info.Caption:='...';
       Sx:='-'+IntToStr(fES_bayes.TrainCycle)+'. -'+IntToStr(fES_bayes.ObjTrain_J);
       J:=fES_bayes.ObjTrain_J;
       if J<0 then J:=0;
       if (J>=0) and (J<lbObj.Items.Count) then begin
          Sx:=Sx+' ('+trim(lbObj.Items[J])+')';
       end
       else begin
          Sx:=Sx+' (???)';
       end;
       Label_CycleNum.Caption:=Sx;
       Application.ProcessMessages;

       Screen.Cursor:=crHourGlass;
       TRY

         fES_bayes.ES_Train_Manual_Next(MemoPropTrue.Lines);

         //-------------------------------------
         fES_bayes.Obj_Rating_to_TStringGrid(sgRating);
         fES_bayes.Rules_to_TStringGrid(sgRules);
         sgRules_SaveToFile;
         //-------------------------------------
         //-------------------------------------
         Memo_Res.Lines.Clear;
         Memo_Res.Lines.Add(' : '+fES_bayes.TrainMode_to_Str(fES_bayes.TrainMode, true));
         Memo_Res.Lines.Add('  : '+fES_bayes.TrainProcessExit_to_Str(fES_bayes.TrainProcessExit, true));
         Memo_Res.Lines.Add(' : '+fES_bayes.TrainResult_to_Str(fES_bayes.TrainResult, true));
         //-------------------------------------
         //-------------------------------------
         for J:=1 to (sgRating.RowCount-1) do
          begin
            sgRating.Cells[1,J]:=lbObj.Items[J-1];
         end;
         //-------------------------------------
         //-------------------------------------
         Label_Info.Font.Color:=clBlack;
         Label_Info.Color:=clBtnFace;
         //-------------------------------------

         //-------------------------------------
         if fES_bayes.TrainResult = trYes then begin
            Label_Info.Font.Color:=clBlack;
            Label_Info.Color:=clAqua;
            Label_Info.Caption:=' !    !';
         end
         else begin
            Label_Info.Font.Color:=clRed;
            Label_Info.Color:=clBtnFace;
            Label_Info.Caption:='   ';
         end;
         //-------------------------------------

         {
         //-------------------------------------
         Memo_Res.Lines.Add('**************************************');
         Memo_Res.Lines.Add(' . : '+DateTimeToStr(NOW));
         Memo_Res.Lines.Add('    : '+fES_bayes.TrainProcessExit_to_Str(fES_bayes.TrainProcessExit), true);
         Memo_Res.Lines.Add('  : '+fES_bayes.TrainResult_to_Str(fES_bayes.TrainResult), true);
         //-------------------------------------
         }

       FINALLY
         Screen.Cursor:=crDefault;
       END;
     end;
  end
  else begin
    ShowMessage('    !');
  end;
end;

function TfMain.sgRules_SaveToFile:boolean;
Var
  I,J:integer;
  Sx:string;
  List:TStrings;
begin
  Result:=false;
  if DirectoryExists(MainDir+sDirTask+Edit_TaskDirName.Text) then begin
     List:=TStringList.Create;
     TRY
       for I := 0 to (sgRules.RowCount-1) do
        begin
         Sx:='';
         for J := 0 to (sgRules.ColCount-1) do
          begin
            Sx:=Sx+'['+sgRules.Cells[j,i]+']';
         end;
         //List.Values[IntToStr(I)]:=Sx;
         List.Add(Sx);
       end;
       List.SaveToFile(MainDir+sDirTask+Edit_TaskDirName.Text+'\'+'Rules.txt');
       //ShowMessage('c');
       Result:=true;
     FINALLY
       FreeAndNil(List);
     END;

  end
  else begin
     ShowMessage('!   : '+MainDir+sDirTask+Edit_TaskDirName.Text);
  end;
end;


function TfMain.sgRules_LoadFromFile(SG:TStringGrid):boolean;
Var
  I,J:integer;
  Sx,S:string;
  List:TStrings;
begin
  Result:=false;
  if Assigned(SG) then begin
     fES_bayes.Rules_TStringGrid_Clear(sgRules);
     if DirectoryExists(MainDir+sDirTask+Edit_TaskDirName.Text) then begin
        if FileExists(MainDir+sDirTask+Edit_TaskDirName.Text+'\'+'Rules.txt') then begin
           List:=TStringList.Create;
           TRY
             List.LoadFromFile(MainDir+sDirTask+Edit_TaskDirName.Text+'\'+'Rules.txt');
             //ShowMessage(List.Text);
             if List.Count>1 then begin
                Sx:=trim(List[0]);
                I:=Get_CountWords_In_String(Sx, '[]');
                if I>1 then begin
                   SG.ColCount :=I;
                   SG.RowCount:=List.Count;
                   for I := 0 to (SG.RowCount-1) do
                    begin
                     Sx:=trim(List[I]);
                     for J := 0 to (SG.ColCount-1) do
                      begin
                        S:=Get_Word_From_String(Sx, J+1, '[]');
                        SG.Cells[j,i]:=S;
                     end;
                   end;
                   Result:=true;
                end;
             end;

           FINALLY
             FreeAndNil(List);
           END;
        end;
     end;
  end;
end;

procedure TfMain.sbStopClick(Sender: TObject);
begin
  Application.ProcessMessages;
  sbStop.Enabled:=false;
  sbStart.Enabled:=true;
  fES_bayes.ES_Train_Exit_UserAbort;
  Memo_Res.Lines.Add('    !');

end;

procedure TfMain.sb_Prop_True_ClearClick(Sender: TObject);
begin
  Application.ProcessMessages;
  MemoPropTrue.Lines.Clear;
end;

procedure TfMain.sb_Prop_True_CreateClick(Sender: TObject);
Var
  I:integer;
begin
  Application.ProcessMessages;
  //11  MemoPropTrue.Lines.Clear;
  if lbObj.ItemIndex>=0 then begin
     for I:=0 to (clbProp.Items.Count-1) do
      begin
       if clbProp.Checked[I] then begin
          MemoPropTrue.Lines.Values[IntToStr(lbObj.ItemIndex)+'_'+IntToStr(I)]:='1';
       end
       else begin
          MemoPropTrue.Lines.Values[IntToStr(lbObj.ItemIndex)+'_'+IntToStr(I)]:='0';
       end;
     end;
  end;
end;



end.



{

 

https://ru.wikipedia.org/wiki/%D0%9D%D0%B0%D1%80%D0%BE%D0%B4%D0%BD%D1%8B%D0%B5_%D0%BF%D1%80%D0%B8%D0%BC%D0%B5%D1%82%D1%8B_%D0%BE_%D0%BF%D0%BE%D0%B3%D0%BE%D0%B4%D0%B5

https://www.yaklass.ru/p/okruzhayushchij-mir/2-klass/raznoobrazie-prirody-320111/iz-chego-skladyvaetsia-pogoda-321250/re-97fed37e-5bc0-45ed-90ec-4a9e81b9b833

http://www.outdoors.ru/weather/weater_land2.php



}
